#ifndef CSVPP_H
#define CSVPP_H

#include <string>
#include <vector>
#include <map>
#include <sstream>
#include <istream>


#define VERSION "2.0"

namespace csvpp {

	class RowWriter;

	class RowReader : public std::map<std::string, std::string> {
		private:
			std::vector<std::string> header;
			bool skipheader;
		public:
			const char * newline;
			RowReader(bool skipheader=false,const char * newline="\n") : skipheader(skipheader), newline(newline) { }
			void clear() { header.clear(); }
			friend std::istream & operator>>(std::istream & os, RowReader & r);
			friend std::ostream & operator<<(std::ostream & os, const RowWriter & r);
	};

	class RowWriter : public std::vector<RowReader>
	{
		public:
			friend std::ostream & operator<<(std::ostream & os, const RowWriter & r);
	};
	
	//typedef std::vector<row> rows;
	typedef RowReader::const_iterator rowiterator;
}

#endif